/*global window, rJS, loopEventListener, RSVP */
/*jslint nomen: true, indent: 2, maxerr: 3*/
(function (window, rJS) {
  "use strict";

  rJS(window)
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    .declareMethod('validateCribEnableGadgetUrl', function (editor_gadget_url) {
      var gadget_validator, gadget = this,
        link = gadget.props.element.querySelector(".interface_validator a");
      link.href = editor_gadget_url;
      link.innerHTML = editor_gadget_url;
      return gadget.getDeclaredGadget("interface_validator")
        .push(function (result) {
          gadget_validator = result;
          return gadget_validator.render({
            gadget_to_check_url: editor_gadget_url,
            required_interface_list: ["crib-enable-interface.html"]
          });
        });
    });
}(window, rJS, loopEventListener));