/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS, Handlebars, document, loopEventListener, RSVP */
(function (window, rJS, document, RSVP) {
  "use strict";

  rJS(window)
    /////////////////////////////////////////////////////////////////
    // ready
    /////////////////////////////////////////////////////////////////

    // Assign the element to a variable
    .ready(function (g) {
      var link_list;
      g.props = {};
      return g.getElement()
        .push(function (element) {
          var promise_list = [];
          link_list = element.querySelectorAll("a.install-app-link");
          g.props.element = element;
          link_list.forEach(function (link) {
            promise_list.push(g.getUrlFor(
              {
                page: "add_application",
                app_name: link.getAttribute("data-app-title"),
                app_id: link.getAttribute("data-app-id"),
                zip_app_url: link.getAttribute("data-app-zip-url")
              }));
          });
          return RSVP.all(promise_list);
        })
        .push(function (url_list) {
          for (var i = 0; i < link_list.length; i++) {
            link_list[i].href = url_list[i];
          }
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .declareMethod('render', function (options) {
    });


}(window, rJS, document, RSVP));